import breeze.numerics.{pow, sqrt}

import scala.collection.mutable.ListBuffer
import math._


object MOPFun {

  var lb : ListBuffer[Double] = new ListBuffer[Double] // 0.0
  var ub : ListBuffer[Double] = new ListBuffer[Double]
  var dim : Int =0
  val rand = new scala.util.Random()
  var bitsPerVariable : ListBuffer[Int] = new ListBuffer[Int]
  //var Fun = #F1

  //function [lb,ub,dim,fobj] =

  def main(args: Array[String]): Unit = {

    /*val (lb, ub, dim ) = GetFunDetail("ZDT2")

    //val lis = RandPop(dim, ub, lb)
    val lis : ListBuffer[Double] = ListBuffer(0.3014,    0.0762,    0.8203,    0.9192,    0.2592)
    ObjFun("ZDT2", lis )

    ObjFun("ZDT3", lis )

    ObjFun("ZDT4", lis )*/

  }

  def RandPop(d: Int, maxCol: ListBuffer[Double], minCol:ListBuffer[Double]): ListBuffer[Double] =
  {

    val rand = new scala.util.Random(System.currentTimeMillis)
    //val result : Array[Vector] = new Array[Vector](k)
    //val Vec = new Array[Double](d)
    var Vec : ListBuffer[Double] =  new ListBuffer[Double]

    var x : Double = 0.0
    //for (h <- 0 until k)
    if (minCol.length == 1)
    {
      for (j <- 0 until d)
      {
        /*x =  rand.nextGaussian() * ( maxCol(0)  - minCol(0) )
        if (x < 0 )
          x = (-1) * x
        x = x + minCol(0)
        if (x > maxCol(0) )
          x = maxCol(0)
        Vec += x*/
        //Vec += minCol(0)  + (rand.nextGaussian() * ( maxCol(0)  - minCol(0) )  )

        Vec += ( minCol(0)  + (rand.nextDouble() * ( maxCol(0)  - minCol(0) )  )  )
      }
    }
    else
    {
      for (j <- 0 until d)
      {
        //Vec += minCol(j)  + (rand.nextGaussian() * ( maxCol(j)  - minCol(j) )  )
        /*x =  rand.nextGaussian() * ( maxCol(j)  - minCol(j) )
        if (x < 0 )
          x = (-1) * x
        x = x + minCol(j)
        if (x > maxCol(j) )
          x = maxCol(j)
        Vec += x*/

        Vec += ( minCol(j)  + (rand.nextDouble() * ( maxCol(j)  - minCol(j) )  )  )

      }
    }
    Vec
  }

  def ObjFun (str: String, x: ListBuffer[Double]) : ListBuffer[Double] =
  {
    var Result : ListBuffer[Double] = new ListBuffer[Double]
    str match  {
      case "ZDT1" => Result = ZDT1(x)

      case "ZDT2" => Result = ZDT2(x)

      case "ZDT3" => Result = ZDT3(x)

      case "ZDT4" => Result = ZDT4(x)

      case "ZDT6" => Result = ZDT6(x)

      case "DTLZ2:1" => Result = DTLZ1(x, 2)

      case "DTLZ2:2" => Result = DTLZ2(x, 2)

      case "DTLZ2:3" => Result = DTLZ3(x, 2)

      case "DTLZ2:4" => Result = DTLZ4(x, 2)

      case "DTLZ2:5" => Result = DTLZ5(x, 2)

      case "DTLZ2:6" => Result = DTLZ6(x, 2)

      case "DTLZ2:7" => Result = DTLZ7(x, 2)

      case "DTLZ3:1" => Result = DTLZ1(x, 3)

      case "DTLZ3:2" => Result = DTLZ2(x, 3)

      case "DTLZ3:3" => Result = DTLZ3(x, 3)

      case "DTLZ3:4" => Result = DTLZ4(x, 3)

      case "DTLZ3:5" => Result = DTLZ5(x, 3)

      case "DTLZ3:6" => Result = DTLZ6(x, 3)

      case "DTLZ3:7" => Result = DTLZ7(x, 3)

      case "UF1" => Result = UF1(x)

      case "UF2" => Result = UF2(x)

      case "UF3" => Result = UF3(x)

      case "UF4" => Result = UF4(x)

      case "UF5" => Result = UF5(x)

      case "UF6" => Result = UF6(x)

      case "UF7" => Result = UF7(x)

      case "UF8" => Result = UF8(x)

      case "UF9" => Result = UF9(x)

      case "UF10" => Result = UF10(x)

    }

    //print(Result)
    return Result
  }

  def GetFunDetail(str: String) :(ListBuffer[Double], ListBuffer[Double], Int) =
  {

    lb.clear()
    ub.clear()
    str match  {
      case "ZDT1" =>
        {
          lb += 0.0
          ub += 1.0
          dim = 30
        }
      case "ZDT2" =>
        {
          lb += 0.0;
          ub +=  1.0;
          dim = 30;
        }
      case "ZDT3" =>
        {
          lb += 0.0;
          ub += 1.0;
          dim = 30;
        }
      case "ZDT4" =>
      {
        lb = ListBuffer(0.0);
        ub = ListBuffer(1.0);
        for (i<-1 until 10)
          {
            lb += -5.0
            ub += 5.0
          }
        dim = 10;
      }
      case "ZDT5" =>
      {
        //generates 80 random integer numbers in range (0, 1)
        lb += 0;
        ub += 1;
        dim = 11;
      }
      case "ZDT6" =>
      {
        lb += 0.0;
        ub += 1.0;
        dim = 10;
      }
      case "DTLZ2:1" =>
      {
        lb += 0.0;
        ub += 1.0;
        dim = 7;
      }
      case "DTLZ2:2" =>
      {
        lb += 0.0;
        ub += 1.0;
        dim = 12;
      }
      case "DTLZ2:3" =>
      {
        lb += 0.0;
        ub += 1.0;
        dim = 12;
      }
      case "DTLZ2:4" =>
      {
        lb += 0.0;
        ub += 1.0;
        dim = 12;
      }
      case "DTLZ2:5" =>
      {
        lb += 0.0;
        ub += 1.0;
        dim = 12;
      }

      case "DTLZ2:6" =>
      {
        lb += 0.0;
        ub += 1.0;
        dim = 12;
      }
      case "DTLZ2:7" =>
      {
        lb += 0.0;
        ub += 1.0;
        dim = 22;
      }

      case "DTLZ3:1" =>
      {
        lb += 0.0;
        ub += 1.0;
        dim = 7;
      }
      case "DTLZ3:2" =>
      {
        lb += 0.0;
        ub += 1.0;
        dim = 12;
      }
      case "DTLZ3:3" =>
      {
        lb += 0.0;
        ub += 1.0;
        dim = 12;
      }
      case "DTLZ3:4" =>
      {
        lb += 0.0;
        ub += 1.0;
        dim = 12;
      }
      case "DTLZ3:5" =>
      {
        lb += 0.0;
        ub += 1.0;
        dim = 12;
      }

      case "DTLZ3:6" =>
      {
        lb += 0.0;
        ub += 1.0;
        dim = 12;
      }
      case "DTLZ3:7" =>
      {
        lb += 0.0;
        ub += 1.0;
        dim = 22;
      }

      case "UF1" =>
      {
        lb  += 0.0;
        ub += 1.0;
        dim=30;
        for ( i<- 1 until dim )
        {
          lb  += -1.0;
          ub += 1.0;
        }
      }

      case "UF2" =>
      {
        lb  += 0.0;
        ub += 1.0;
        dim=30;
        for ( i<- 1 until dim )
        {
          lb  += -1.0;
          ub += 1.0;
        }
      }

      case "UF3" =>
      {
        lb  += 0.0;
        ub += 1.0;
        dim=30;
      }

      case "UF4" =>
      {
        lb  += 0.0;
        ub += 1.0;
        dim=30;
        for ( i<- 1 until dim )
        {
          lb  += -2.0;
          ub += 2.0;
        }
      }

      case "UF5" =>
      {
        lb  += 0.0;
        ub += 1.0;
        dim=30;
        for ( i<- 1 until dim )
        {
          lb  += -1.0;
          ub += 1.0;
        }
      }

      case "UF6" =>
      {
        lb  += 0.0;
        ub += 1.0;
        dim=30;
        for ( i<- 1 until dim )
        {
          lb  += -1.0;
          ub += 1.0;
        }
      }

      case "UF7" =>
      {
        lb  += 0.0;
        ub += 1.0;
        dim=30;
        for ( i<- 1 until dim )
        {
          lb  += -1.0;
          ub += 1.0;
        }
      }

      case "UF8" =>
      {
        lb  += 0.0;
        ub += 1.0;
        lb  += 0.0;
        ub += 1.0;
        dim=30;
        for ( i<- 2 until dim )
        {
          lb  += -2.0;
          ub += 2.0;
        }
      }

      case "UF9" =>
      {
        lb  += 0.0;
        ub += 1.0;
        lb  += 0.0;
        ub += 1.0;
        dim=30;
        for ( i<- 2 until dim )
        {
          lb  += -2.0;
          ub += 2.0;
        }
      }

      case "UF10" =>
      {
        lb  += 0.0;
        ub += 1.0;
        lb  += 0.0;
        ub += 1.0;
        dim=30;
        for ( i<- 2 until dim )
        {
          lb  += -2.0;
          ub += 2.0;
        }
      }

    }
    (lb, ub, dim)
  }


  def EvalG(x: ListBuffer[Double]) : Double = {

    var s1 : Double = 0.0

    for (i<- 1 until x.length)
    {
      s1 = s1 + ( x(i) )
    }

    val g : Double = 1 + (9 * s1/ ( x.length.asInstanceOf[Double] - 1 ))

    return g

  }


  def ZDT1(x: ListBuffer[Double]) : ListBuffer[Double] =
  {
    //g =  1+9.*sum(x(:,2:end),2)./(size(x,2)-1)
    //[x(:,1), g(x).*(1-sqrt(x(:,1)./g(x)))];

    //lb += 0.0;
    //ub += 1.0;
    dim=30;
    val NumberOfObjectives : Int = 2
    var o : ListBuffer[Double] = new ListBuffer[Double]//(NumberOfObjectives)
    o += x(0)

    var g : Double = 0.0;

    for ( i <- 1 until( x.length))
    {
      g = g + x(i);
    }
    val constant : Double = 9.0 / (x.length.asInstanceOf[Double] - 1.0);
    g = constant * g;
    g = g + 1.0;
    //val t : Double = EvalG(x)
    var h : Double = 0.0 ;
    h = 1.0 - Math.sqrt(o(0) / g);
    //val h : Double = 1 - ( pow( ( o(0) / t), 2 ) )
    //val o : ListBuffer[Double] = ListBuffer(f, (t * h) )

    o += h * g

    return o
  }



  def ZDT2(x: ListBuffer[Double]) : ListBuffer[Double] =
  {
    //f = @(x) x(:,1);
    //g = @(x) 1+9.*sum(x(:,2:end),2)./(size(x,2)-1);
    //h = @(x) 1-(f(x)./g(x)).^2;
    //MultiObj.fun = @(x) [f(x), g(x).*h(x)];

    //lb += 0.0;
    //ub += 1.0;
    dim=30;
    val NumberOfObjectives : Int = 2
    var o : ListBuffer[Double] = new ListBuffer[Double]//(NumberOfObjectives)
    o += x(0)

    var g : Double = 0.0;

    for ( i <- 1 until( x.length))
    {
      g = g + x(i);
    }
    val constant : Double = 9.0 / (x.length.asInstanceOf[Double] - 1.0).asInstanceOf[Double];
    g = constant * g;
    g = g + 1.0;
    //val t : Double = EvalG(x)
    var h : Double = 0.0 ;
    h = 1.0 - Math.pow(o(0) / g, 2.0);

    o += h * g

    return o
  }

  def ZDT3(x: ListBuffer[Double]) : ListBuffer[Double] =
  {
    //f = @(x) x(:,1);
    //g  = @(x) 1+(9/size(x,2)-1).*sum(x(:,2:end),2);
    //h  = @(x) 1 - sqrt(f(x)./g(x)) - (f(x)./g(x)).*sin(10.*pi.*f(x));
    //MultiObj.fun = @(x) [f(x), g(x).*h(x)];


    //lb += 0.0;
    //ub += 1.0;
    dim=30;
    val NumberOfObjectives : Int = 2
    var o : ListBuffer[Double] = new ListBuffer[Double]//(NumberOfObjectives)
    o += x(0)

    var g : Double = 0.0;

    for ( i <- 1 until( x.length))
    {
      g = g + x(i);
    }
    val constant : Double = 9.0 / (x.length.asInstanceOf[Double] - 1.0).asInstanceOf[Double];
    g = constant * g;
    g = g + 1.0;
    //val t : Double = EvalG(x)
    var h : Double = 0.0 ;
    h =  1.0 - sqrt(o(0) / g) - (o(0) / g) * sin(10.0 * Pi * o(0));

    o += h * g

    return o

  }

  def ZDT4(x: ListBuffer[Double]) : ListBuffer[Double] =
  {
    //PopObj(:,1) = PopDec(:,1);
    //g = 1+10*(size(PopDec,2)-1)+sum(PopDec(:,2:end).^2-10*cos(4*pi*PopDec(:,2:end)),2);
    //h = 1-(PopObj(:,1)./g).^0.5;
    //PopObj(:,2) = g.*h;


    //lb = ListBuffer(0.0,-5.0,-5.0,-5.0,-5.0,-5.0,-5.0,-5.0,-5.0,-5.0);
    //ub = ListBuffer(1.0,5.0,5.0,5.0,5.0,5.0,5.0,5.0,5.0,5.0);
    dim = 10;

    val NumberOfObjectives : Int = 2
    var o : ListBuffer[Double] = new ListBuffer[Double]//(NumberOfObjectives)
    o += x(0)

    var g : Double = 0.0;

    for ( i <- 1 until( x.length))
    {
      g= g + Math.pow(x(i), 2.0) - 10.0 * cos(4.0 * Pi * x(i) )

    }
    val constant : Double = 1.0 + 10.0 * (x.length.asInstanceOf[Double] - 1.0).asInstanceOf[Double]
    g = g + constant

    //val t : Double = EvalG(x)
    var h : Double = 0.0 ;
    h = 1.0 - Math.sqrt(o(0) / g)

    o += h * g

    return o
  }

  /*def getBitsPerVariable(index: Int): Int = {
    if ((index < 0) || (index >= this.dim)) throw new Nothing("Index value is incorrect: " + index)
    bitsPerVariable(index)
  }*/

  def ZDT5(x: ListBuffer[Double]) : ListBuffer[Double] =
  {
    //u      = zeros(size(PopDec,1),1+(size(PopDec,2)-30)/5);
    //u(:,1) = sum(PopDec(:,1:30),2);
    //for i = 2 : size(u,2)
    //u(:,i) = sum(PopDec(:,(i-2)*5+31:(i-2)*5+35),2);
    //end
    //v           = zeros(size(u));
    //v(u<5)      = 2 + u(u<5);
    //v(u==5)     = 1;
    //PopObj(:,1) = 1 + u(:,1);
    //g           = sum(v(:,2:end),2);
    //h           = 1./PopObj(:,1);
    //PopObj(:,2) = g.*h;


    //lb += 0
    //ub += 1
    dim = 11;

    bitsPerVariable = new ListBuffer[Int]
    bitsPerVariable(0) = 30
    for ( i <- 1 until( x.length))
    {
      bitsPerVariable(i) = 5
    }

    val NumberOfObjectives = 2
    var o = ListBuffer[Double](NumberOfObjectives)


    //o(0) = 1 + u(x(0))

    var g = 0.0;

    for ( i <- 1 until( x.length))
    {
      g= g + Math.pow(x(i), 2.0) - 10.0 * cos(4.0 * Pi * x(i) )
    }
    val constant = 1.0 + 10.0 * (x.length.asInstanceOf[Double] - 1.0)
    g = g + constant

    //val t : Double = EvalG(x)
    var h = 0.0 ;
    h = 1.0 - Math.sqrt(o(0) / g)

    o(1) = h * g

    return o
  }

  def ZDT6(x: ListBuffer[Double]) : ListBuffer[Double] =
  {
    //PopObj(:,1) = 1-exp(-4*PopDec(:,1)).*sin(6*pi*PopDec(:,1)).^6;
    //g = 1+9*sum(PopDec(:,2:end),2).^0.25;
    //h = 1-(PopObj(:,1)./g).^2;
    //PopObj(:,2) = g.*h;

    val NumberOfObjectives : Int = 2
    var o : ListBuffer[Double] = new ListBuffer[Double]//(NumberOfObjectives)

    val x1 = x(0)
    o += 1.0 - exp((-4.0) * x1) * Math.pow(Math.sin(6.0 * Math.PI * x1), 6.0)

    var g : Double = 0.0

    for ( i <- 1 until x.length )
    {
      g = g + x(i)
    }
    g = g / ( x.length.asInstanceOf[Double] - 1.0).asInstanceOf[Double];
    g = Math.pow(g, 0.25);
    g = 9.0 * g;
    g = 1.0 + g;

    val h : Double = 1.0 - Math.pow( (o(0) / g), 2.0)
    o += h * g;

    //val o : ListBuffer[Double] = ListBuffer(f, (gg * h) )

    return o
  }

  def DTLZ1(sol: ListBuffer[Double], m : Integer) : ListBuffer[Double] =
  {
    //PopDec = input;
    //[N,D]  = size(PopDec);
    //M      = Global.M; = 3
    //g      = 100*(D-M+1+sum((PopDec(:,M:end)-0.5).^2-cos(20.*pi.*(PopDec(:,M:end)-0.5)),2));
    //PopObj = 0.5*repmat(1+g,1,M).*fliplr(cumprod([ones(N,1),PopDec(:,1:M-1)],2)).*[ones(N,1),1-PopDec(:,M-1:-1:1)];

    //val m : Int = 3;
    val n : Int = 1
    val d : Int = sol.length


    var f: ListBuffer[Double] = new ListBuffer[Double]//(m) //new double[numberOfObjectives];
    var x: ListBuffer[Double] = new ListBuffer[Double]//(sol.length) //= new double[numberOfVariables] ;

    val k : Int = sol.length - m + 1;

    for ( i <- 0 until sol.length )
    {
        x += sol(i) ;
    }

    for ( i <- 0 until m )
    {
      f += 0
    }


    var g : Double = 0.0

    for ( i <- x.length - k until  x.length )
    {
        g = g +  (x(i) - 0.5) * (x(i) - 0.5) - Math.cos(20.0 * Math.PI * (x(i) - 0.5));
    }

    g = 100 * (k + g);

    for ( i <- 0 until  m )
    {
      f(i) = (1.0 + g) * 0.5;
    }

    for ( i <- 0 until m)
    {
      for ( j <- 0  until m - (i + 1))
      {
        f(i) = f(i) * x(j);
      }
      if (i != 0)
      {
        val aux : Int  = m - (i + 1);
        f(i) = f(i) * ( 1 - x(aux) )
      }
    }

    return f
  }

  def DTLZ2(sol: ListBuffer[Double], m : Integer) : ListBuffer[Double] =
  {
    //PopDec = input;
    //[N,D]  = size(PopDec);
    //M      = Global.M; = 3
    //g      = 100*(D-M+1+sum((PopDec(:,M:end)-0.5).^2-cos(20.*pi.*(PopDec(:,M:end)-0.5)),2));
    //PopObj = 0.5*repmat(1+g,1,M).*fliplr(cumprod([ones(N,1),PopDec(:,1:M-1)],2)).*[ones(N,1),1-PopDec(:,M-1:-1:1)];

    //val m : Int = 3;
    val n : Int = 1
    val d : Int = sol.length


    var f: ListBuffer[Double] = new ListBuffer[Double]//(m) //new double[numberOfObjectives];
    var x: ListBuffer[Double] = new ListBuffer[Double]//(sol.length) //= new double[numberOfVariables] ;

    val k : Int = sol.length - m + 1;

    for ( i <- 0 until sol.length )
    {
      x += sol(i) ;
    }

    for ( i <- 0 until m )
    {
      f += 0
    }

    var g : Double = 0.0;
    for ( i <- sol.length - k until sol.length)
    {
        g += (x(i) - 0.5) * (x(i) - 0.5);
    }

    for ( i <- 0 until m )
    {
      f(i) = 1.0 + g;
    }

    for ( i <- 0 until m)
    {
      for ( j <- 0 until m - (i + 1) )
      {
        f(i) = f(i) * ( Math.cos(x(j) * 0.5 * Math.PI));
      }
      if (i != 0)
      {
        val aux : Int = m - (i + 1);
        f(i) = f(i) * ( Math.sin(x(aux) * 0.5 * Math.PI) );
      }
    }

    return f
  }

  def DTLZ3(sol: ListBuffer[Double], m : Integer) : ListBuffer[Double] =
  {
    //PopDec = input;
    //[N,D]  = size(PopDec);
    //M      = Global.M; = 3
    //g      = 100*(D-M+1+sum((PopDec(:,M:end)-0.5).^2-cos(20.*pi.*(PopDec(:,M:end)-0.5)),2));
    //PopObj = 0.5*repmat(1+g,1,M).*fliplr(cumprod([ones(N,1),PopDec(:,1:M-1)],2)).*[ones(N,1),1-PopDec(:,M-1:-1:1)];

    //val m : Int = 3;
    val n : Int = 1
    val d : Int = sol.length


    var f: ListBuffer[Double] = new ListBuffer[Double]//(m) //new double[numberOfObjectives];
    var x: ListBuffer[Double] = new ListBuffer[Double]//(sol.length) //= new double[numberOfVariables] ;

    val k : Int = sol.length - m + 1;

    for ( i <- 0 until sol.length )
    {
      x += sol(i) ;
    }

    for ( i <- 0 until m )
    {
      f += 0
    }

    var g : Double = 0.0;
    for (  i <- sol.length - k until sol.length )
    {
        g = g + ( (x(i) - 0.5) * (x(i) - 0.5) - Math.cos(20.0 * Math.PI * (x(i) - 0.5))   );
    }

    g = 100.0 * (k + g);
    for ( i <- 0 until  m)
    {
      f(i) = 1.0 + g;
    }

    for (  i <- 0 until m)
    {
      for ( j <- 0 until m - (i + 1))
      {
        f(i) = f(i) * ( cos(x(j) * 0.5 * Pi) );
      }
      if (i != 0)
      {
        val aux : Int = m - (i + 1);
        f(i) = f(i) * ( sin(x(aux) * 0.5 * Pi) );
      }
    }


    return f
  }

  def DTLZ4(sol: ListBuffer[Double], m : Integer) : ListBuffer[Double] =
  {
    //PopDec = input;
    //[N,D]  = size(PopDec);
    //M      = Global.M; = 3
    //g      = 100*(D-M+1+sum((PopDec(:,M:end)-0.5).^2-cos(20.*pi.*(PopDec(:,M:end)-0.5)),2));
    //PopObj = 0.5*repmat(1+g,1,M).*fliplr(cumprod([ones(N,1),PopDec(:,1:M-1)],2)).*[ones(N,1),1-PopDec(:,M-1:-1:1)];

    //val m : Int = 3;
    val n : Int = 1
    val alpha: Double  = 100.0;
    val d : Int = sol.length


    var f: ListBuffer[Double] = new ListBuffer[Double]//(m) //new double[numberOfObjectives];
    var x: ListBuffer[Double] = new ListBuffer[Double]//(sol.length) //= new double[numberOfVariables] ;

    val k : Int = sol.length - m + 1;

    for ( i <- 0 until sol.length )
    {
      x += sol(i) ;
    }

    for ( i <- 0 until m )
    {
      f += 0
    }

    var g : Double = 0.0;

    for ( i <- sol.length - k until sol.length)
    {
      g = g + (x(i) - 0.5) * (x(i) - 0.5);
    }

    for ( i <- 0 until  m )
    {
      f(i) = 1.0 + g;
    }

    for ( i <- 0 until m )
    {
      for ( j <- 0 until m - (i + 1) )
      {
        f(i) = f(i) * (cos(pow(x(j), alpha) * (Pi / 2.0)))
      }
      if (i != 0)
      {
        val aux : Int = m - (i + 1);
        f(i) *= f(i) * (sin(pow(x(aux), alpha) * (Pi / 2.0)));
      }
    }

    return f
  }

  def DTLZ5(sol: ListBuffer[Double], m : Integer) : ListBuffer[Double] =
  {
    //val m : Int = 3;
    val n : Int = 1
    val alpha: Double  = 100.0;
    val d : Int = sol.length

    var theta : ListBuffer[Double] = new ListBuffer[Double] //double[numberOfObjectives - 1];
    var g : Double = 0.0;

    var f: ListBuffer[Double] = new ListBuffer[Double]//(m) //new double[numberOfObjectives];
    var x: ListBuffer[Double] = new ListBuffer[Double]//(sol.length) //= new double[numberOfVariables] ;

    val k : Int = sol.length - m + 1;

    for ( i <- 0 until sol.length )
    {
      x += sol(i) ;
    }

    for ( i <- 0 until m )
    {
      f += 0
    }

    for (i <- sol.length - k until  sol.length)
    {
        g = g + ( (x(i) - 0.5) * (x(i) - 0.5) );
    }

    val  t : Double = Pi / (4.0 * (1.0 + g));

    theta += x(0) * Pi / 2.0;
    for ( i <- 1 until (m - 1))
    {
      theta += t * (1.0 + 2.0 * g * x(i));
    }

    for (  i <- 0 until m )
    {
      f(i) = 1.0 + g;
    }

    for (  i <- 0 until m )
    {
      for ( j <- 0 until m - (i + 1))
      {
        f(i) = f(i) * cos(theta(j));
      }
      if (i != 0)
      {
        val aux :  Int = m - (i + 1);
        f(i) =  f(i) * sin(theta(aux));
      }
    }

    return f
  }


  def DTLZ6(sol: ListBuffer[Double], m : Integer) : ListBuffer[Double] =
  {

    //val m : Int = 3;
    val n : Int = 1
    val d : Int = sol.length

    var theta : ListBuffer[Double] = new ListBuffer[Double] //double[numberOfObjectives - 1];
    var g : Double = 0.0;
    var f: ListBuffer[Double] = new ListBuffer[Double]//(m) //new double[numberOfObjectives];
    var x: ListBuffer[Double] = new ListBuffer[Double]//(sol.length) //= new double[numberOfVariables] ;

    val k : Int = sol.length - m + 1;

    for ( i <- 0 until sol.length )
    {
      x += sol(i) ;
    }

    for ( i <- 0 until m )
    {
      f += 0
    }

    for ( i <- sol.length - k until sol.length )
    {
      g = g + pow(x(i), 0.1);
    }

    val t: Double = Pi / (4.0 * (1.0 + g));
    theta += x(0) * Pi / 2.0;
    for (  i <- 1 until (m - 1))
    {
      theta += t * (1.0 + 2.0 * g * x(i));
    }

    for (  i <- 0 until m )
    {
      f(i) = 1.0 + g;
    }

    for (  i <- 0 until m )
    {
      for (  j <- 0 until m - (i + 1))
      {
        f(i) = f(i) *  cos(theta(j));
      }
      if (i != 0)
      {
        val aux : Int = m - (i + 1);
        f(i) = f(i) * ( sin(theta(aux)) );
      }
    }

    return f
  }

  def DTLZ7(sol: ListBuffer[Double], m : Integer) : ListBuffer[Double] =
  {


    //val m : Int = 3;
    val n : Int = 1
    val d : Int = sol.length

    var theta : ListBuffer[Double] = new ListBuffer[Double] //double[numberOfObjectives - 1];
    var g : Double = 0.0;
    var f: ListBuffer[Double] = new ListBuffer[Double]//(m) //new double[numberOfObjectives];
    var x: ListBuffer[Double] = new ListBuffer[Double]//(sol.length) //= new double[numberOfVariables] ;

    val k : Int = sol.length - m + 1;

    for ( i <- 0 until sol.length )
    {
      x += sol(i) ;
    }

    for ( i <- 0 until m )
    {
      f += 0
    }

    for ( i <- sol.length - k until sol.length)
    {
        g = g +  x(i);
    }

    g = 1 + (9.0 * g) / k.asInstanceOf[Double];

    //System.arraycopy(x, 0, f, 0, m - 1)

    for ( i <- 0 until m-1)
      {
        f(i) = x(i)
      }


    var h : Double = 0.0;
    for ( i <-  0 until m - 1)
    {
      h = h + ( (f(i) / (1.0 + g)) * (1 + sin(3.0 * Pi * f(i) )) );
    }

    h = m - h;

    f(m - 1) = (1 + g) * h;

    return f
  }

  def UF1(sol: ListBuffer[Double]) : ListBuffer[Double] =
  {

    val m : Int = 2;
    var x : ListBuffer[Double] = new ListBuffer[Double];
    for ( i <- 0 until sol.length )
    {
      x += sol(i) ;
    }

    var count1 : Int=0
    var count2 : Int=0

    var sum1, sum2, yj : Double = 0.0

    for ( j <- 2  to x.length )
    {
      yj = x(j-1) - Math.sin(6.0*Pi*x(0) + j*Math.PI/sol.length.asInstanceOf[Double]);
      yj = yj * yj;
      if(j % 2 == 0)
      {
        sum2 += yj;
        count2 = count2 + 1;
      }
      else
      {
        sum1 += yj;
        count1 = count1 + 1;
      }
    }
    var f : ListBuffer[Double] = new ListBuffer[Double]
    f += x(0) + 2.0 * sum1 / count1.asInstanceOf[Double]
    f += 1.0 - Math.sqrt(x(0)) + 2.0 * sum2 / count2.asInstanceOf[Double]

    //solution.setObjective(0, x[0] + 2.0 * sum1 / (double)count1);
    //solution.setObjective(1, 1.0 - Math.sqrt(x[0]) + 2.0 * sum2 / (double)count2);

    return f
  }

  def UF2(sol: ListBuffer[Double]) : ListBuffer[Double] =
  {

    val m : Int = 2;
    var x : ListBuffer[Double] = sol //new ListBuffer[Double];
    /*for ( i <- 0 to sol.length )
    {
      x += sol(i) ;
    }*/

    var count1 : Int=0
    var count2 : Int=0

    var sum1, sum2, yj : Double = 0.0

    for (  j <- 2 to sol.length)
    {
      if(j % 2 == 0)
      {
        yj = x(j-1) -
        (0.3 * x(0) * x(0) * Math.cos(24 * Math.PI * x(0) + 4 * j * Math.PI / sol.length) + 0.6 * x(0))*
        Math.sin(6.0 * Math.PI* x(0) + j * Math.PI / sol.length.asInstanceOf[Double]);
        sum2 += yj*yj;
        count2 = count2 + 1;
      }
      else
      {
        yj = x(j-1) -
          (0.3 * x(0) * x(0) * Math.cos(24 * Math.PI * x(0) + 4 * j * Math.PI / x.length) + 0.6 * x(0))*
          Math.cos(6.0 * Math.PI* x(0) + j * Math.PI / sol.length.asInstanceOf[Double]);

        sum1 += yj*yj;
        count1 = count1 + 1;
      }
    }


    var f : ListBuffer[Double] = new ListBuffer[Double]
    f += x(0) + 2.0 * sum1 / count1.asInstanceOf[Double]
    f += 1.0 - Math.sqrt(x(0)) + 2.0 * sum2 / count2.asInstanceOf[Double]

    return f
  }

  def UF3(sol: ListBuffer[Double]) : ListBuffer[Double] =
  {

    val m : Int = 2;
    var x : ListBuffer[Double] = new ListBuffer[Double];
    for ( i <- 0 until sol.length )
    {
      x += sol(i) ;
    }

    var count1 : Int=0
    var count2 : Int=0

    var sum1, sum2, prod1, prod2, yj, pj : Double = 0.0
    sum1 = 0.0
    sum2   = 0.0
    prod1  = 1.0
    prod2  = 1.0;


    for ( j <- 2 to x.length)
    {
      yj = x(j-1)-Math.pow(x(0),0.5*(1.0+3.0*(j-2.0)/(sol.length.asInstanceOf[Double] -2.0)));
      pj = Math.cos(20.0*yj*Math.PI/Math.sqrt(j));
      if (j % 2 == 0)
      {
        sum2  += yj*yj;
        prod2 *= pj;
        count2=count2+1;
      }
      else
      {
        sum1  += yj*yj;
        prod1 *= pj;
        count1=count1+1;
      }
    }


    var f : ListBuffer[Double] = new ListBuffer[Double]
    f +=  x(0) + 2.0*(4.0*sum1 - 2.0*prod1 + 2.0) / count1.asInstanceOf[Double]
    f += 1.0 - Math.sqrt(x(0)) + 2.0*(4.0*sum2 - 2.0*prod2 + 2.0) / count2.asInstanceOf[Double]

    return f

  }

  def UF4(sol: ListBuffer[Double]) : ListBuffer[Double] =
  {

    val m: Int = 2;
    var x: ListBuffer[Double] = new ListBuffer[Double];
    for (i <- 0 until sol.length) {
      x += sol(i) ;
    }

    var count1, count2 : Int = 0
    var sum1, sum2, yj, hj : Double = 0.0

    for ( j <- 2  to sol.length)
    {
      yj = x(j-1)-Math.sin(6.0*Math.PI*x(0)+j*Math.PI/x.length.asInstanceOf[Double]);
      hj = Math.abs(yj)/(1.0+Math.exp(2.0*Math.abs(yj)));
      if (j % 2 == 0)
      {
        sum2  += hj;
        count2 = count2 + 1;
      }
      else
      {
        sum1 = sum1 + hj;
        count1 = count1 + 1;
      }
    }

    var f : ListBuffer[Double] = new ListBuffer[Double]
    f +=  x(0) + 2.0 * sum1 / count1.asInstanceOf[Double]
    f += 1.0 - x(0)*x(0) + 2.0 * sum2 / count2.asInstanceOf[Double]

    return f


  }

  def UF5(sol: ListBuffer[Double]) : ListBuffer[Double] =
  {

    val m: Int = 2;
    val epsilon : Double = 0.1
    val N : Int = 10
    val numberOfVariables : Int = 30


    var x: ListBuffer[Double] = new ListBuffer[Double];
    for (i <- 0 until sol.length) {
      x += sol(i) ;
    }

    var count1, count2 : Int = 0 ;
    var sum1, sum2, yj, hj : Double = 0.0 ;


    for ( j <- 2 to  sol.length)
    {
      yj = x(j-1)-Math.sin(6.0*Math.PI*x(0)+j*Math.PI/x.length);
      hj = 2.0*yj*yj - Math.cos(4.0*Math.PI*yj) + 1.0;
      if (j % 2 == 0)
      {
        sum2  += hj;
        count2= count2 + 1;
      }
      else
      {
        sum1  = sum1  + hj;
        count1 = count1 + 1;
      }
    }
    hj = (0.5/N.asInstanceOf[Double] + epsilon)*Math.abs(Math.sin(2.0*N*Math.PI*x(0)));

    var f : ListBuffer[Double] = new ListBuffer[Double]
    f +=  x(0) + hj + 2.0*sum1 / count1.asInstanceOf[Double]
    f += 1.0 - x(0) + hj + 2.0*sum2 / count2.asInstanceOf[Double]

    return f

  }

  def UF6(sol: ListBuffer[Double]) : ListBuffer[Double] =
  {

    val m: Int = 2;
    val epsilon : Double = 0.1
    val N : Int = 2
    val numberOfVariables : Int = 30


    var x: ListBuffer[Double] = new ListBuffer[Double];
    for (i <- 0 until sol.length) {
      x += sol(i) ;
    }

    var  count1, count2 : Int = 0
    var prod1, prod2 : Double = 1.0
    var sum1, sum2, yj, hj, pj : Double = 0.0

    for ( j <- 2 to  sol.length)
    {
      yj = x(j-1)-Math.sin(6.0*Math.PI*x(0)+j*Math.PI/sol.length.asInstanceOf[Double]);
      pj = Math.cos(20.0*yj*Math.PI/Math.sqrt(j));
      if (j % 2 == 0)
      {
        sum2  += yj*yj;
        prod2 *= pj;
        count2 = count2 + 1;
      }
      else
      {
        sum1  += yj*yj;
        prod1 *= pj;
        count1 = count1 + 1;
      }
    }
    hj = 2.0*(0.5/N.asInstanceOf[Double] + epsilon)*Math.sin(2.0*N.asInstanceOf[Double]*Math.PI*x(0));
    if (hj < 0.0)
      {   hj = 0.0;     }

    var f : ListBuffer[Double] = new ListBuffer[Double]
    f +=  x(0) + hj + 2.0*(4.0*sum1 - 2.0*prod1 + 2.0) / count1.asInstanceOf[Double]
    f += 1.0 - x(0) + hj + 2.0*(4.0*sum2 - 2.0*prod2 + 2.0) / count2.asInstanceOf[Double]

    return f

  }

  def UF7(sol: ListBuffer[Double]) : ListBuffer[Double] =
  {

    val m: Int = 2;
    val epsilon : Double = 0.1
    val N : Int = 2
    val numberOfVariables : Int = 30


    var x: ListBuffer[Double] = new ListBuffer[Double];
    for (i <- 0 until sol.length) {
      x += sol(i) ;
    }

    var count1, count2 : Int = 0
    var sum1, sum2, yj : Double = 0.0
    //sum1   = sum2   = 0.0;
    //count1 = count2 = 0;

    for ( j <- 2 to  x.length )
    {
      yj = x(j-1) - Math.sin(6.0*Math.PI*x(0)+j*Math.PI/x.length.asInstanceOf[Double]);
      if (j % 2 == 0)
      {
        sum2  += yj*yj;
        count2 = count2 + 1;
      }
      else
      {
        sum1  += yj*yj;
        count1 = count1 + 1;
      }
    }
    yj = Math.pow(x(0),0.2);


    var f : ListBuffer[Double] = new ListBuffer[Double]
    f +=  yj + 2.0*sum1 / count1.asInstanceOf[Double]
    f +=  1.0 - yj + 2.0*sum2 / count2.asInstanceOf[Double]

    return f

  }

  def UF8(sol: ListBuffer[Double]) : ListBuffer[Double] =
  {

    val m: Int = 3;
    val epsilon : Double = 0.1
    val N : Int = 2
    val numberOfVariables : Int = 30


    var x: ListBuffer[Double] = new ListBuffer[Double];
    for (i <- 0 until sol.length) {
      x += sol(i) ;
    }

    var count1, count2, count3 : Int = 0
    var sum1, sum2, sum3, yj : Double = 0.0

    for ( j <- 3 to x.length )
    {
      yj = x(j-1) - 2.0*x(1)*Math.sin(2.0*Math.PI*x(0)+j*Math.PI/x.length.asInstanceOf[Double]);
      if(j % 3 == 1) {
        sum1  += yj*yj;
        count1 += 1;
      }
      else if(j % 3 == 2)
      {
        sum2  += yj*yj;
        count2 += 1;
      }
      else
      {
        sum3  += yj*yj;
        count3 += 1;
      }
    }


    var f : ListBuffer[Double] = new ListBuffer[Double]
    f +=  Math.cos(0.5*Math.PI*x(0))*Math.cos(0.5*Math.PI*x(1)) + 2.0*sum1 / count1.asInstanceOf[Double]
    f +=  Math.cos(0.5*Math.PI*x(0))*Math.sin(0.5*Math.PI*x(1)) + 2.0*sum2 / count2.asInstanceOf[Double]
    f +=  Math.sin(0.5*Math.PI*x(0)) + 2.0*sum3 / count3.asInstanceOf[Double]

    return f

  }

  def UF9(sol: ListBuffer[Double]) : ListBuffer[Double] =
  {

    val m: Int = 3;
    val epsilon : Double = 0.1
    val N : Int = 2
    val numberOfVariables : Int = 30


    var x: ListBuffer[Double] = new ListBuffer[Double];
    for (i <- 0 until sol.length) {
      x += sol(i) ;
    }

    var count1, count2, count3: Int = 0;
    var sum1, sum2, sum3, yj : Double = 0.0;
    //sum1   = sum2 = sum3 = 0.0;
    //count1 = count2 = count3 = 0;

    for ( j <- 3 to x.length)
    {
      yj = x(j-1) - 2.0*x(1)*Math.sin(2.0*Math.PI*x(0)+j*Math.PI/x.length.asInstanceOf[Double]);
      if(j % 3 == 1)
      {
        sum1  += yj*yj;
        count1+= 1;
      }
      else if(j % 3 == 2)
      {
        sum2  += yj*yj;
        count2+= 1;
      }
      else {
        sum3  += yj*yj;
        count3+= 1;
      }
    }

    yj = (1.0+epsilon)*(1.0-4.0*(2.0*x(0)-1.0)*(2.0*x(0)-1.0));
    if (yj < 0.0)
      { yj = 0.0; }


    var f : ListBuffer[Double] = new ListBuffer[Double]
    f +=  0.5*(yj + 2*x(0))*x(1) + 2.0*sum1 / count1.asInstanceOf[Double]
    f +=  0.5*(yj - 2*x(0) + 2.0)*x(1) + 2.0*sum2 / count2.asInstanceOf[Double]
    f +=  1.0 - x(1) + 2.0*sum3 / count3.asInstanceOf[Double]

    return f

  }

  def UF10(sol: ListBuffer[Double]) : ListBuffer[Double] =
  {

    val m: Int = 3;
    val epsilon : Double = 0.1
    val N : Int = 2
    val numberOfVariables : Int = 30


    var x: ListBuffer[Double] = new ListBuffer[Double];
    for (i <- 0 until sol.length)
    {
      x += sol(i) ;
    }

    var count1, count2, count3: Int = 0;
    var sum1, sum2, sum3, yj, hj : Double = 0.0;

    //int count1, count2, count3;
    //double sum1, sum2, sum3, yj, hj;

    for (  j <- 3 to x.length)
    {
      yj = x(j-1) - 2.0*x(1)*Math.sin(2.0*Math.PI*x(0)+j*Math.PI/x.length.asInstanceOf[Double]);
      hj = 4.0*yj*yj - Math.cos(8.0*Math.PI*yj) + 1.0;
      if(j % 3 == 1)
      {
        sum1  += hj;
        count1+= 1;
      }
      else if(j % 3 == 2)
      {
        sum2  += hj;
        count2+= 1;
      }
      else
      {
        sum3  += hj;
        count3+= 1;
      }
    }


    var f : ListBuffer[Double] = new ListBuffer[Double]
    f +=  Math.cos(0.5*Math.PI*x(0))*Math.cos(0.5*Math.PI*x(1)) + 2.0*sum1 / count1.asInstanceOf[Double]
    f +=  Math.cos(0.5*Math.PI*x(0))*Math.sin(0.5*Math.PI*x(1)) + 2.0*sum2 / count2.asInstanceOf[Double]
    f +=  Math.sin(0.5*Math.PI*x(0)) + 2.0*sum3 / count3.asInstanceOf[Double]

    return f

  }



}
