
import BLAS.{axpy, scal}
import MOWOATSKM.findClosest
import org.apache.spark.SparkContext
import org.apache.spark.mllib.linalg.{Vector, Vectors}
import org.apache.spark.rdd.RDD
import org.apache.spark.sql.{DataFrame, Row, SparkSession}
import org.apache.spark.sql.types.{StringType, StructField, StructType}

import scala.collection.mutable.ListBuffer
//import java.util._
import org.apache.spark.sql.DataFrame
import org.apache.spark.mllib.linalg.Vector

import java.io.InputStream
import java.io.InputStreamReader
import java.util.StringTokenizer
import java.io.BufferedReader
import java.io.FileInputStream
import java.io.IOException

import scala.io.Source
import com.github.martincooper
import collection.mutable.Map

import scala.concurrent.ExecutionContext.Implicits.global
import scala.concurrent.Await
import scala.concurrent.duration._

import scala.concurrent.ExecutionContext
import slick.lifted.TableQuery
import slick.jdbc.JdbcBackend.Database
import scala.concurrent.ExecutionContext.Implicits.global
import scala.concurrent._
import ExecutionContext.Implicits.global


import java.sql.DriverManager
import java.sql.Connection

object run
{
  def main(args: Array[String]): Unit =
  {
    //val db = Database.forURL("jdbc:sqlite:/home/Downloads/org.Hs.eg.sqlite", driver = "org.sqlite.JDBC")
    //val action = "select chromosome from chromosomes"
    //val result = db.run(action) //Await.result(db.run(action), 2 seconds)
    //val x = StaticQuery.updateNA("").execute

    //
    //
    //result.foreach(println)


    val url = "jdbc:sqlite:/home/amr/Downloads/org.Hs.eg.sqlite"
    //val username = "root"
    //val password = "root"

    var c:Connection = null
    val driver = "org.sqlite.JDBC"
    Class.forName(driver).newInstance();
    c = DriverManager.getConnection(url)//null

    // make the connection
    //Class.forName(driver)
    //, username, password)

    // create the statement, and run the select query
    val statement = c.createStatement()
    val resultSet = statement.executeQuery("SELECT chromosome from chromosomes")
    while ( resultSet.next() )
    {
      val host = resultSet.getString("chromosome")
      //val user = resultSet.getString("user")
      println("chromosome = " + host )
    }

    c.close()

  }
}

class WangSim {

  var spark : SparkSession = null
  var GOFrame : DataFrame = null

  def main(args: Array[String]): Unit =
  {

    //db.run(action).foreach(println)
  }

  def BioValidIndice () =
  {
    spark = SparkSession.builder().master("local[*]").appName("DFS Read Write Test").getOrCreate()
    val sc = spark.sparkContext
    //import spark.implicits._

    val sqlContext = new org.apache.spark.sql.SQLContext(sc)

    val lspark = spark
    /////Load Gene Ontology
    import lspark.implicits._
    val  schema_str = "id,go_id,Term,Ontology,relationship,parent"
    val schema = StructType(schema_str.split(",")
      .map(fieldName => StructField(fieldName, StringType, true)) )
    val squidString = sc.textFile("hdfs://master:9000/amr/gotbl.txt") //textFile("/home/amr/Downloads/gotbl.txt")
    val rowRDD = squidString.map(_.split(";")).map(x => Row(x(0), x(1), x(2), x(3), x(4), x(5) ))
    GOFrame = sqlContext.createDataFrame(rowRDD, schema)
  }

  def WangDistCenters(centers: Array[Vector], p : Vector ) : (Int, Double) =
  {

    var index : Int = 0
    var MinDist : Double = Double.PositiveInfinity
    var Temp : Double = 0.0

    for ( i<- 0 until centers.length)
    {
      //"go_id"
      Temp = WangSim(centers(i).toArray(0).toString, p.toArray(0).toString)
      if (Temp < MinDist )
      {
        MinDist = Temp
        index = i
      }
    }

    return(index, MinDist)

  }

  def WangSim(p1: String, p2: String ): Double =
  {
    var diff: Double = 0.0
    val spark = SparkSession.builder().master("local[*]").appName("DFS Read Write Test").getOrCreate()
    val sc = spark.sparkContext
    //import spark.implicits._

    //val GOFrame = LoadGOFrame()//sqlContext.createDataFrame(rowRDD, schema)
    //val vv = squidDF.where(($"id" === "\"1\""))
    var ont : String = ""
    val x = GetSV(p1, ont, spark)
    val y = GetSV(p2, ont, spark)

    if (x.values.toList.length == 0 | y.values.toList.length == 0 )
    {
      return -100 //there is a problem
    }

    val Inter = x.keySet.intersect(y.keySet)
    var xSum : Double = 0
    for ( i<- 0 until Inter.toList.length)
    {
      xSum = xSum + x(Inter.toList(i))
    }

    //var ySum : Double = 0
    for ( i<- 0 until Inter.toList.length)
    {
      xSum = xSum + y(Inter.toList(i))
    }

    //x, y
    var TotalSum : Double = 0.0
    for ( i<-0 until x.values.toList.length )
    {
      TotalSum +=  x.values.toList(i)
    }

    for ( i<-0 until y.values.toList.length )
    {
      TotalSum +=  y.values.toList(i)
    }

    val sim : Double =  xSum / TotalSum

    return sim
  }

  //SparkSession
  def GetSV (ID : String, ont: String, spark : org.apache.spark.sql.SparkSession) : Map[String,Double] =
  {
    import spark.implicits._
    //val whereDF = explodeDF.where(($"firstName" === "xiangrui") || ($"firstName" === "michael")).sort($"lastName".asc)
    val weight : ListBuffer[Double] =  ListBuffer[Double](0.8, 0.6, 0.7)
    //names(weight) <- c("is_a", "part_of", "other")
    var ont : String = "BP" //c("BP", "CC", "MF")
    var topNode : String = ""
    var sv : ListBuffer[Double] = new ListBuffer[Double]//0.0
    var A:Map[String,Double] = Map()

    if (ont == "DO")
    {
      topNode = "DOID:4"
    }
    else
    {
      topNode = "all"
    }

    if (ID == topNode)
    {
      sv += 1.0
      //names(sv) <- topNode
      A += (topNode.toString -> 1.0)

      return (A)
    }


    val rel_df = GOFrame.where($"Ontology" === "\"" + ont + "\"" ) //&& ($"firstName" === "michael"))    //$"Ontology" === "\""+ont+"\" && ")  //     rel_df[rel_df$Ontology == ont,]
    //val rel_df = GOFrame.where(($"firstName" === "xiangrui") && ($"firstName" === "michael")).sort($"lastName".asc)

    //check if the relationship columns exists in the table
    //if (  "relationship" in    rel_df.filter($"relationship" === "") )



    /*rel_df <- rel_df[rel_df$Ontology == ont,]
    if (! 'relationship' %in% colnames(rel_df))
    rel_df$relationship <- "other"*/

    //rel_df$relationship[!rel_df$relationship %in% c("is_a", "part_of")] <- "other"



    //names(sv) <- ID
    var allid : ListBuffer[String] = new ListBuffer[String]
    sv += 1.0
    allid += ID

    A += (ID.toString -> 1.0)

    //idx <- which(rel_df[,1] %in% ID)

    var idx = rel_df.filter($"go_id" === "\""+ ID.toString() + "\"")
    var Index : Int = 0
    while (idx.count() != 0) //(length(idx) != 0)
    {
      //var p =  idx //  rel_df[idx,]
      //pid <- p$parent

      var pid : String= idx("parent").toString()

      //if (! (pid eq null)) {
      //allid <- c(allid, pid)
      //allid += pid
      //names(weight) <- c("is_a", "part_of", "other")
      //sv <- c(sv, weight[p$relationship]*sv[p[,1]])
      //Index = allid.indexOf(idx("go_id").toString)

      if (idx("relationship").toString() == "is_a")
      {
        //sv += ( weight(0) * sv(Index) )//sv[p[,1]]
        A += (pid.toString -> weight(0) * A(pid.toString) )
      }
      else if (idx("relationship").toString() == "part_of")
      {
        //sv += ( weight(1) * sv(Index) )
        A += (pid.toString -> weight(1) * A(pid.toString) )
      }
      else if (idx("relationship").toString() == "other")
      {
        //sv += ( weight(2) * sv(Index) )
        A += (pid.toString -> weight(2) * A(pid.toString) )
      }
      //names(sv) <- allid
      //}

      //idx <- which(rel_df[,1] %in% pid)
      idx = rel_df.filter($"go_id" === "\"" + pid.toString() + "\"")

    }

    //remove null values in map
    A.remove("")
    //redmove duplicate
    val xx = A.map { case e@(_, v) => v.toString -> e }.values.toMap
    A = collection.mutable.Map(xx.toSeq: _*)


    //val dupList = sv.distinct


    //sv <- sv[!is.na(names(sv))]
    //sv <- sv[!duplicated(names(sv))]

    if(ont != "DO")
    {
      //xx.get(topNode.toString).toSet(0.0)// = 0.0
      //sv[topNode] = 0
      A(topNode.toString) = 0
      /*for ( i <- 0 until allid.length)
        {
          if (allid(i) == topNode.toString)
            {
              sv(i) = 0
            }
        }*/
    }


    /*if( ! exists(ID, envir=.SemSimCache) )
    {
      assign(ID,  sv,   envir=.SemSimCache)
    }*/

    return A

  }




}
