import breeze.linalg.sum
import breeze.numerics.pow
import scala.math

import scala.collection.mutable.ListBuffer

object WhaleFun {

  var lb : ListBuffer[Double] = new ListBuffer[Double] // 0.0
  var ub : ListBuffer[Double] = new ListBuffer[Double]
  var dim : Int =0
  val rand = new scala.util.Random()
  //var Fun = #F1

  //function [lb,ub,dim,fobj] =


  def ObjFun (str: String, x: ListBuffer[Double]) :Double=
  {
    var Result : Double = 0.0
    str match  {
      case "F1" => Result = F1(x)

      case "F2" => Result = F2(x)

      case "F3" => Result = F3(x)

      case "F4" => Result = F4(x)

      case "F5" => Result = F5(x)

      case "F6" => Result = F6(x)

      case "F7" => Result = F7(x)

      case "F8" => Result = F8(x)

      case "F9" => Result = F9(x)

      case "F10" => Result = F10(x)

      case "F11" => Result = F11(x)

      case "F12" => Result = F12(x)

      case "F13" => Result = F13(x)

      case "F14" => Result = F14(x)

      case "F15" => Result = F15(x)

      case "F16" => Result = F16(x)

      case "F17" => Result = F17(x)

      case "F18" => Result = F18(x)

      case "F19" => Result = F19(x)

      case "F20" => Result = F20(x)

      case "F21" => Result = F21(x)

      case "F22" => Result = F22(x)

      case "F23" => Result = F23(x)

    }

    return Result
  }

  def GetFunDetail(str: String) :(ListBuffer[Double], ListBuffer[Double], Int) =
  {

    lb.clear()
    ub.clear()
    str match  {
      case "F1" =>
        {
          lb += -100.0
          ub += 100.0
          dim = 30
        }
      case "F2" =>
        {
          lb += -10;
          ub +=  10;
          dim = 30;
        }
      case "F3" =>
        {
          lb += -100;
          ub += 100;
          dim = 30;
        }
      case "F4" =>
      {
        lb += -100;
        ub += 100;
        dim = 30;
      }
      case "F5" =>
      {
        lb += -30;
        ub += 30;
        dim = 30;
      }
      case "F6" =>
      {
        lb += -100;
        ub += 100;
        dim = 30;
      }
      case "F7" =>
      {
        lb += -1.28;
        ub += 1.28;
        dim = 30;
      }
      case "F8" =>
      {
        lb += -500;
        ub += 500;
        dim = 30;
      }
      case "F9" =>
      {
        lb += -5.12;
        ub += 5.12;
        dim = 30;
      }
      case "F10" =>
      {
        lb += -32;
        ub += 32;
        dim = 30;
      }
      case "F11" =>
      {
        lb += -600;
        ub += 600;
        dim = 30;
      }
      case "F12" =>
      {
        lb += -50;
        ub += 50;
        dim = 30;
      }
      case "F13" =>
      {
        lb  += -50;
        ub += 50;
        dim=30;
      }
      case "F14" =>
      {
        lb += -65.536;
        ub += 65.536;
        dim = 2;
      }
      case "F15" =>
      {
        lb += -5;
        ub += 5;
        dim=4;
      }
      case "F16" =>
      {
        lb += -5;
        ub += 5;
        dim = 2;
      }
      case "F17" =>
      {
        //lb= [-5,0];
        //ub= [10,15];
        lb += -5
        lb += 0

        ub += 10
        ub += 15
        dim= 2;
      }
      case "F18" =>
      {
        lb += -2;
        ub += 2;
        dim=2;
      }
      case "F19" =>
      {
        lb += 0;
        ub += 1;
        dim = 3;
      }
      case "F20" =>
      {
        lb += 0;
        ub += 1;
        dim = 6;
      }
      case "F21" =>
      {
        lb += 0;
        ub += 10;
        dim = 4;
      }
      case "F22" =>
      {
        lb += 0;
        ub += 10;
        dim = 4;
      }
      case "F23" =>
      {
        lb += 0;
        ub += 10;
        dim = 4;
      }
    }
    (lb, ub, dim)
  }

  def F1(x: ListBuffer[Double]) :Double=
  {
    var o :Double = 0
    for (i<- 0 until x.length)
      {
        o = o + math.pow(x(i),2)
      }
    //val o= sum(x.^2);
    return o
  }

  def F2(x: ListBuffer[Double]) : Double=
  {
    //o = sum(abs(x)) + prod(abs(x))
    var o :Double = 0
    var sum :Double = 0
    var prod :Double = 1
    for (i<- 0 until x.length)
    {
      sum = sum + math.abs(x(i))
    }
    for (i<- 0 until x.length)
    {
      prod = prod * math.abs(x(i))
    }
    o = sum + prod
    return o
  }

  def F3(x: ListBuffer[Double]) : Double=
  {
    var o :Double = 0
    var v :Double = 0
    for (i<- 0 until x.length)
    {
      v = v + math.pow( getSum( x, i ) , 2)
    }
    o = v
    return o
  }

  def getSum(x: ListBuffer[Double], count : Int) : Double =
  {
    //reassement
    var sum :Double = 0.0
    for (j<- 0 to count )
      {
        sum = sum + x(j)
      }
    return  sum
  }

  def F4(x: ListBuffer[Double]) : Double =
  {
    /*  o = max(abs(x))  */
    var o :Double = math.abs(x(0))
    for (i<- 1 until x.length)
    {
      if ( o < math.abs(x(i)) )
      {   o = math.abs(x(i))  }
    }
    return o
  }

  def F5(x: ListBuffer[Double]) : Double =
  {
    /*dim=size(x,2);
      o=sum(100*(x(2:dim)-(x(1:dim-1).^2)).^2+(x(1:dim-1)-1).^2); */

    var t: ListBuffer[Double] = new ListBuffer[Double]
    for (i<- 0 until x.length-1)
    {
      t += ( 100 * pow((x(i+1)-pow(x(i), 2)), 2) ) +
          pow((x(i)-1), 2)
    }
    var o :Double = sum(t)

    return o
  }

  def F6(x: ListBuffer[Double]) : Double =
  {
    /*  o=sum(abs((x+.5)).^2);*/
    var o :Double = 0
    for (i<- 0 until x.length)
    {
      o = o + math.pow( math.abs(x(i) + 0.5) ,2 )
    }
    return o
  }

  def F7(x: ListBuffer[Double]) : Double =
  {
    /*  dim=size(x,2);
    o=sum([1:dim].*(x.^4))+rand;;*/
    var o :Double = 0.0
    var sum : Double = 0.0
    var t = x.clone()
    for (i<- 0 until x.length)
    {
      t(i) = math.pow( x(i) , 4)
    }

    for (i<- 0 until x.length)
    {
      o = o +( x(i) * t(i) )
    }
    o = o +rand.nextDouble()
    return o
  }

  def F8(x: ListBuffer[Double]) : Double =
  {
    /* o=sum(-x.*sin(sqrt(abs(x)))); */
    var o :Double = 0
    var t = x.clone()
    for (i<- 0 until x.length)
    {
      o = o +( (-1) * x(i)  * math.sin( math.sqrt( math.abs(x(i)))   ) )
    }
    return o
  }

  def F9(x: ListBuffer[Double]) : Double =
  {
    /* o=sum(x.^2-10*cos(2*pi.*x))+10*dim; */
    var o :Double = 0
    for (i<- 0 until x.length)
    {
      o = o +( math.pow(x(i),2) - ( 10 * math.cos(  2 * math.Pi * x(i)  ) ) )
    }
    o = o + ( 10 * x.length )
    return o
  }

  def F10(x: ListBuffer[Double]) : Double =
  {
    /* o=-20*exp(-.2*sqrt(sum(x.^2)/dim))-exp(sum(cos(2*pi.*x))/dim)+20+exp(1); */
    var cosList  = mult(x, 2 * math.Pi).clone()
    for (i<- 0 until x.length)
    {
      cosList(i) = math.cos(cosList(i))
    }
    var t1 : Double = sum(cosList) / x.length


    var o :Double = 0

    o = (-20) * math.exp((-.2) * math.sqrt(sum(x,2) / x.length )) -
      math.exp(t1) + 20 + math.exp(1)
    return o
  }

  def sum(x: ListBuffer[Double], p: Double = 0.0 ) : Double =
  {
    var s :Double = 0.0
    for ( k<- 0 until x.length)
    {
      if ( p > 0 )
      {
        s = s + math.pow(x(k), p)
      }
      else
      {
        s = s + x(k)
      }
    }
    return s
  }

  def mult(x: ListBuffer[Double], Num: Double) : ListBuffer[Double] =
  {
    var t : ListBuffer[Double] = new ListBuffer[Double]
    for (j<- 0 until x.length)
      {
        t += Num * x(j)
      }
    return t
  }

  def F11(x: ListBuffer[Double]) : Double =
  {
    /* dim=size(x,2);
    o=sum(x.^2)/4000-prod(cos(x./sqrt([1:dim])))+1; */
    val t1 : Double = sum(x,2)/4000

    var tList  = x.clone()
    var prod : Double = 1.0
    for (i<- 0 until x.length)
    {
      prod = prod * math.cos( x(i) / math.sqrt(i+1) )
    }

    var o :Double = 0
    o = t1 - prod + 1

    return o
  }

  def F12(x: ListBuffer[Double]) : Double =
  {

    //o=(pi/dim)*(10*((sin(pi*(1+(x(1)+1)/4)))^2)+sum((((x(1:dim-1)+1)./4).^2).*...
    //(1+10.*((sin(pi.*(1+(x(2:dim)+1)./4)))).^2))+((x(dim)+1)/4)^2)+sum(Ufun(x,10,100,4))

    val t1 : Double = (math.Pi/x.length)
    val t2 : Double = 10* math.pow((math.sin(math.Pi *(1+(x(0)+1)/4))),2)
    var l1 = new ListBuffer[Double]
    for (i<- 0 until(x.length-1))
    {
      l1 += math.pow( ( (x(i) + 1) / 4 ) , 2)
    }

    var l2 = new ListBuffer[Double]
    for (i<- 1 until(x.length))
    {
      l2 += (1+(10*math.pow(math.sin(math.Pi*(1+((x(i)+1)/4))), 2))) * l1(i-1)
    }
    val t3 = sum(l2)
    val t4 =  math.pow(((x(x.length-1) + 1) /4),2)

    var o :Double = 0
    o = t1 * (t2 + t3 +t4)
    o = o + sum(Ufun(x,10,100,4) )

    return o
  }

  def Ufun(x: ListBuffer[Double],a: Double,k : Double,m: Double) : ListBuffer[Double] =
  {
    //k.*((x - a).^ m).*(x > a) + k.*((-x - a).^ m).*(x < (-a));
    var t1List : ListBuffer[Double] = new ListBuffer[Double]
    var t2List : ListBuffer[Double] = new ListBuffer[Double]
    var t3List : ListBuffer[Double] = new ListBuffer[Double]

    for ( i<- 0 until x.length )
    {
      if ( x(i) > a )
        {t1List +=  k * math.pow( (x(i) - a) , m ) }
      else
        {t1List += 0   }
    }

    for ( i<- 0 until x.length )
    {
      if ( x(i) < (-a) )
      { t2List +=  k * math.pow( (-x(i) - a) , m ) }
      else
      { t2List += 0   }
    }

    for ( i<- 0 until x.length )
    {
      t3List += t1List(i) + t2List(i)
    }
    t3List
  }

  def F13(x: ListBuffer[Double]) : Double =
  {

    //o=.1*((sin(3*pi*x(1)))^2+sum((x(1:dim-1)-1).^2.*(1+(sin(3.*pi.*x(2:dim))).^2))+...
    //((x(dim)-1)^2)*(1+(sin(2*pi*x(dim)))^2))+sum(Ufun(x,5,100,4));


    val t1 : Double = math.pow(math.sin(3*math.Pi*x(0)),2)
    var l1 = new ListBuffer[Double]
    for (i<- 0 until(x.length-1))
    {
      l1 += math.pow( ( (x(i) - 1) ) , 2)
    }

    var l2 = new ListBuffer[Double]
    for (i<- 1 until(x.length))
    {
      l2 += (1+math.pow((math.sin(3*math.Pi*x(i))),2)) * l1(i-1)
    }

    val t2 : Double = sum(l2)
    val t3 : Double = math.pow((x(x.length-1) - 1), 2)
    val t4 : Double = 1 + math.pow(math.sin(2* math.Pi*x(x.length-1)), 2)

    val t5 : Double = 0.1*(t1 + t2 + (t3 * t4))


    val o = t5 + sum(Ufun(x,5,100,4) )

    return o
  }


  def F14(x: ListBuffer[Double]) : Double =
  {
    var aS :  Array[List[Double]] = new Array[List[Double]](2)
    aS(0) = List(-32, -16, 0, 16, 32, -32, -16, 0, 16, 32, -32, -16, 0,
            16, 32, -32, -16, 0, 16, 32, -32, -16, 0, 16, 32)
    aS(1) = List(-32, -32, -32, -32, -32, -16, -16, -16, -16, -16, 0, 0, 0, 0,
      0, 16, 16, 16, 16, 16, 32, 32, 32, 32, 32)

    var bS : ListBuffer[Double] = new ListBuffer[Double]()
    var bS2 : ListBuffer[Double] = new ListBuffer[Double]()
    var tList : ListBuffer[Double] = new ListBuffer[Double]()
    var t1 :Double = 0.0
    for (j<- 0  until 25 )
      {
        tList.clear()
        tList +=  math.pow((x(0) - aS(0)(j)),6)
        tList += math.pow((x(1) - aS(1)(j)),6)
        bS += sum(tList)
        //bS(j)=sum((x'-aS(:,j)).^6);
      }

    for (j<- 0  until 25 )
    {
      bS2 +=  ( 1 / ( (j+1) + bS(j) ) )
      //bS(j)=sum((x'-aS(:,j)).^6);
    }

    val t2 = sum(bS2)
    val o = math.pow( ((1.0/500.0) + t2), -1 )

    return o

  }

  def F15(x: ListBuffer[Double]) : Double =
  {
    //aK=[0.1957, 0.1947, 0.1735, 0.16, 0.0844, 0.0627, 0.0456, 0.0342, 0.0323,
    //        0.0235, 0.0246);
    //bK=[.25 .5 1 2 4 6 8 10 12 14 16];bK=1./bK;

    var aK : ListBuffer[Double] = ListBuffer (0.1957, 0.1947, 0.1735, 0.16, 0.0844, 0.0627,
      0.0456, 0.0342, 0.0323, 0.0235, 0.0246)

    var bK : ListBuffer[Double] =
      ListBuffer(0.25, 0.5, 1, 2, 4, 6, 8, 10, 12, 14, 16)

    for (j<- 0  until bK.length )
    {
      bK(j) = (1 / bK(j))
    }

    //o=sum((aK-((x(1).*(bK.^2+x(2).*bK))./(bK.^2+x(3).*bK+x(4)))).^2);
    var tList = bK.clone()

    for (j<- 0  until bK.length )
    {
      tList(j) = math.pow( ( aK(j) - ( ( x(0) * ( math.pow(bK(j), 2) + x(1) * bK(j) ) ) /
        ( math.pow(bK(j), 2) + x(2)*bK(j) + x(3)   ) ) ) , 2)
    }

    val o = sum(tList)

    return o

  }

  def F16(x: ListBuffer[Double]) : Double =
  {
    //o=4*(x(1)^2)-2.1*(x(1)^4)+(x(1)^6)/3+x(1)*x(2)-4*(x(2)^2)+4*(x(2)^4);

    val o = 4 * (math.pow(x(0),2)) - 2.1 * (math.pow(x(0), 4)) +
      (math.pow(x(0), 6)) / 3 + x(0) * x(1) - 4 * ( math.pow(x(1), 2) ) +
      4 * ( math.pow(x(1), 4) )

    return o

  }

  def F17(x: ListBuffer[Double]) : Double =
  {
    //o=4*(x(1)^2)-2.1*(x(1)^4)+(x(1)^6)/3+x(1)*x(2)-4*(x(2)^2)+4*(x(2)^4);

    val o = math.pow( (x(1) - (math.pow(x(0), 2)) * 5.1 / (4 * ( math.pow(math.Pi, 2) )) +
      5 / math.Pi * x(0) - 6) , 2) + 10 * (1 - 1 / (8 * math.Pi)) * math.cos(x(0)) + 10

    return o

  }

  def F18(x: ListBuffer[Double]) : Double =
  {
    //o=4*(x(1)^2)-2.1*(x(1)^4)+(x(1)^6)/3+x(1)*x(2)-4*(x(2)^2)+4*(x(2)^4);

    val o = (1.0+math.pow((x(0)+x(1)+1.0),2.0)*(19.0-14.0*x(0)+3.0*(math.pow(x(0),2.0))-
      14.0*x(1)+6.0*x(0)*x(1)+ 3.0*math.pow(x(1),2.0))) *
      (30.0+math.pow((2.0*x(0)-3.0*x(1)),2.0)*(18.0-32.0*x(0)+
      12.0*(math.pow(x(0),2.0))+48.0*x(1)-36.0*x(0)*x(1)+27.0*(math.pow(x(1),2))))

    return o

  }

  def F19(x: ListBuffer[Double]) : Double =
  {

    var aH :  ListBuffer[ListBuffer[Double]] = new ListBuffer[ListBuffer[Double]]//(4)
    aH += ListBuffer(3, 10, 30)
    aH += ListBuffer(0.1, 10, 35)
    aH += ListBuffer(3, 10, 30)
    aH += ListBuffer(0.1, 10, 35)

    var cH :  ListBuffer[Double] = ListBuffer(1, 1.2, 3, 3.2)

    var pH :  ListBuffer[ListBuffer[Double]] = new ListBuffer[ListBuffer[Double]]//(4)
    pH += ListBuffer(0.3689, 0.117, 0.2673)
    pH += ListBuffer(0.4699, 0.4387, 0.747)
    pH += ListBuffer(0.1091, 0.8732, 0.5547)
    pH += ListBuffer(0.03815, 0.5743, 0.8828)

    var o : Double = 0

    var tList = aH(0).clone()


    for ( i<- 0 until pH.length)
    {
      tList.clear()
      for ( j <- 0 until pH(i).length)
      {
        tList += aH(i)(j) * ( pow( x(j) - pH(i)(j), 2) )
      }

      o = o - cH(i) * math.exp(-(sum(tList)))
    }

    return o

  }

  def sumMatrix(x: ListBuffer[ListBuffer[Double]], byRow:Boolean = true) :
  ListBuffer[Double] =
  {
    var tList : ListBuffer[Double] = new ListBuffer[Double]
    var t1 : Double = 0.0
    if ( byRow == false )
    {
      for ( c<- 0 until x(0).length)
      {
        t1 = 0
        for ( r<- 0 until x.length )
        {
          t1 = t1 + x(r)(c)
        }
        tList += t1
      }
      return tList
    }
    else if ( byRow == true )
    {
      for ( r<- 0 until x.length)
      {
        t1 = 0
        for ( c<- 0 until x(0).length )
        {
          t1 = t1 + x(r)(c)
        }
        tList += t1
      }
      return tList
    }

    return tList


  }

  def F20(x: ListBuffer[Double]) : Double =
  {

    var aH :  ListBuffer[ListBuffer[Double]] = new ListBuffer[ListBuffer[Double]]//(4)
    aH += ListBuffer(10, 3, 17, 3.5, 1.7, 8)
    aH += ListBuffer(0.05, 10, 17, 0.1, 8, 14)
    aH += ListBuffer(3, 3.5, 1.7, 10, 17, 8)
    aH += ListBuffer(17, 8, 0.05, 10, 0.1, 14)

    var cH :  ListBuffer[Double] = ListBuffer(1, 1.2, 3, 3.2)

    var pH :  ListBuffer[ListBuffer[Double]] = new ListBuffer[ListBuffer[Double]]//(4)
    pH += ListBuffer(0.1312, 0.1696, 0.5569, 0.0124, 0.8283, 0.5886)
    pH += ListBuffer(0.2329, 0.4135, 0.8307, 0.3736, 0.1004, 0.9991)
    pH += ListBuffer(0.2348, 0.1415, 0.3522, 0.2883, 0.3047, 0.6650)
    pH += ListBuffer(0.4047, 0.8828, 0.8732, 0.5743, 0.1091, 0.0381)

    var o : Double = 0

    var tList = aH(0).clone()


    for ( i<- 0 until pH.length)
    {
      tList.clear()
      for ( j <- 0 until pH(i).length)
      {
        tList += aH(i)(j) * ( pow( x(j) - pH(i)(j), 2) )
      }

      o = o - cH(i) * math.exp(-(sum(tList)))
    }

    return o

  }

  def F21(x: ListBuffer[Double]) : Double =
  {

    var aSH :  ListBuffer[ListBuffer[Double]] = new ListBuffer[ListBuffer[Double]]//(4)
    aSH += ListBuffer(4, 4, 4, 4)
    aSH += ListBuffer(1, 1, 1, 1)
    aSH += ListBuffer(8, 8, 8, 8)
    aSH += ListBuffer(6, 6, 6, 6)
    aSH += ListBuffer(3, 7, 3, 7)
    aSH += ListBuffer(2, 9, 2, 9)
    aSH += ListBuffer(5, 5, 3, 3)
    aSH += ListBuffer(8, 1, 8, 1)
    aSH += ListBuffer(6, 2, 6, 2)
    aSH += ListBuffer(7, 3.6, 7, 3.6)

    var cSH:ListBuffer[Double] = ListBuffer(0.1, 0.2, 0.2, 0.4, 0.4, 0.6, 0.3, 0.7, 0.5, 0.5)

    var o : Double = 0
    var tList = aSH(0).clone()
    var t1 : Double = 0.0

    for ( i<- 0 until 5)
    {
      tList.clear()
      for ( j <- 0 until aSH(i).length)
      {
        tList += ( x(j) - aSH(i)(j) ) * ( x(j) - aSH(i)(j) )
      }

      o = o - pow(sum(tList) + cSH(i) , -1)
    }

    return o

  }

  def F22(x: ListBuffer[Double]) : Double =
  {

    var aSH :  ListBuffer[ListBuffer[Double]] = new ListBuffer[ListBuffer[Double]]//(4)
    aSH += ListBuffer(4, 4, 4, 4)
    aSH += ListBuffer(1, 1, 1, 1)
    aSH += ListBuffer(8, 8, 8, 8)
    aSH += ListBuffer(6, 6, 6, 6)
    aSH += ListBuffer(3, 7, 3, 7)
    aSH += ListBuffer(2, 9, 2, 9)
    aSH += ListBuffer(5, 5, 3, 3)
    aSH += ListBuffer(8, 1, 8, 1)
    aSH += ListBuffer(6, 2, 6, 2)
    aSH += ListBuffer(7, 3.6, 7, 3.6)

    var cSH:ListBuffer[Double] = ListBuffer(0.1, 0.2, 0.2, 0.4, 0.4, 0.6, 0.3, 0.7, 0.5, 0.5)

    var o : Double = 0
    var tList = aSH(0).clone()
    var t1 : Double = 0.0

    for ( i<- 0 until 7)
    {
      tList.clear()
      for ( j <- 0 until aSH(i).length)
      {
        tList += ( x(j) - aSH(i)(j) ) * ( x(j) - aSH(i)(j) )
      }

      o = o - pow(sum(tList) + cSH(i) , -1)
    }

    return o

  }

  def F23(x: ListBuffer[Double]) : Double =
  {

    var aSH :  ListBuffer[ListBuffer[Double]] = new ListBuffer[ListBuffer[Double]]//(4)
    aSH += ListBuffer(4, 4, 4, 4)
    aSH += ListBuffer(1, 1, 1, 1)
    aSH += ListBuffer(8, 8, 8, 8)
    aSH += ListBuffer(6, 6, 6, 6)
    aSH += ListBuffer(3, 7, 3, 7)
    aSH += ListBuffer(2, 9, 2, 9)
    aSH += ListBuffer(5, 5, 3, 3)
    aSH += ListBuffer(8, 1, 8, 1)
    aSH += ListBuffer(6, 2, 6, 2)
    aSH += ListBuffer(7, 3.6, 7, 3.6)

    var cSH:ListBuffer[Double] = ListBuffer(0.1, 0.2, 0.2, 0.4, 0.4, 0.6, 0.3, 0.7, 0.5, 0.5)

    var o : Double = 0
    var tList = aSH(0).clone()
    var t1 : Double = 0.0

    for ( i<- 0 until 10)
    {
      tList.clear()
      for ( j <- 0 until aSH(i).length)
      {
        tList += ( x(j) - aSH(i)(j) ) * ( x(j) - aSH(i)(j) )
      }

      o = o - pow(sum(tList) + cSH(i) , -1)
    }

    return o

  }


}
